// APPHelper.h: interface for the APPHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APPHELPER_H__F41D99AE_3171_426F_B928_7854773D682A__INCLUDED_)
#define AFX_APPHELPER_H__F41D99AE_3171_426F_B928_7854773D682A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//  Aml Pages Plugin API
#include "Plugins.h"

/*
      Aml Pages
  , ..        
   APPHelper::FunctionName(...)
*/

enum AML_OPTIONS_COLORS {AOC_TREEBK=0,AOC_TREEFONT=1};
enum AML_OPTIONS_FONTS  {AOF_TREEFONT=0, AOF_EDITORFONT=1};

struct APPHelper  
{
	static BOOL RemoveAttachmentToRecycledBin(const WORD wDocID, const int nIndex);
	static BOOL IsHasAPC_REMOVEATTACHMENTEX();
	static WORD GetUILanguage();
	static UINT MessageBoxWith2Radio(const HWND hwndParent, UINT nType, LPCTSTR lpszTitle, LPCTSTR lpszText, LPCTSTR lpszRadio1, LPCTSTR lpszRadio2, UINT& nRadio);
	static int GetActivePage(const WORD wDocID=AML_ACTIVEDOCUMENTID);
	static BOOL GetAttachment(const WORD wDocID, const int nIndex, AML_ATTACHINFO* p);
	static int EnumAttachments(WORD wDocID, PFUNC_ENUMATTACHMENTSPROC pfn, LPARAM lParam, LPCTSTR lpszINFOID=NULL, int nPageID=(AML_NOCHECKPAGEID));//   
	static BOOL AddAttachment(WORD wDocID, AML_ATTACHINFO* p);//    
	static BOOL SetAttachment(WORD wDocID, int nIndex, AML_ATTACHINFO* p);//    
	static BOOL RemoveAttachment(WORD wDocID, int nIndex);//    
	static BOOL AddStringToAttachment(WORD wDocID,LPCTSTR lpsz, LPCTSTR lpszInfoID, const int nPageID);// C-     
	
	static LRESULT Command(UINT nCmd, WPARAM wParam, LPARAM lParam);//  ( ,  ,    ..)
	static BOOL MessageBoxWithCheckBoxEx(AML_MBCHECKINFO* pInfo);//MessageBox    
	static BOOL SetStatusBarText(BSTR bstr);//    Aml Pages
	static BOOL MessageBoxWithRadioBox(AML_MBRADIOINFO* pInfo);// MessageBox     (radiobuttons)
	static BOOL GetModuleVersionInfoEx(HMODULE hModule, AML_MODULEVERSIONINFO* pInfo);//  
	static BOOL RichOut(AML_RICHEDITIO *p);//   RichEdit
	static BOOL RichIn(AML_RICHEDITIO *p);//   RichEdit
	static BOOL PluginAbout(AML_PLUGINABOUTINFO* pInfo);//  
	static BOOL GetAutoTextCommand(AML_AUTOTEXTCOMMAND* pCmd);//  
	static BOOL GetOptions(AML_OPTIONS* pOpt);//   Aml Pages
	static BOOL ReReadPluginsInfo(HMODULE hModule);//    Aml Pages (hModule -           )
	static BOOL GetModuleVersionInfo(LPCTSTR lpszPathName/*  */, AML_MODULEVERSIONINFO* pVersionInfo/*   */);
	static UINT GetAmlPagesBuildNumber();//   Aml Pages
	static HWND GetMainHWND();// HWND   Aml Pages
	static BOOL ConvertText(LPCTSTR lpszInText/* */,BSTR* pbstrOutText/*  -   */, const BOOL bRTF2Text/*TRUE -  RTF   , FALSE -     */);//  RTF<->PlainText
	static BOOL MessageBoxWithCheckBox(LPCTSTR lpszText/* */,UINT uType/* */,LPCTSTR lpszCheckBoxText/* */,BOOL* pbChecked/* ,   */,int* pnRet/*  MessageBox*/);// MessageBox  
	static BOOL DisplayPasswordDialog(BSTR* pbstrPassword/*  -   */,BOOL bSetupPassword/*TRUE -  ,  */,BOOL bTopMost/*TRUE -   */,LPCTSTR lpszPrevPassword/*. ,   NULL*/,BOOL bShowOnEnter/*   */,LPCTSTR lpszTitle/*   */);//  
	static BOOL PluginAbout(LPCTSTR lpszAbout, LPCTSTR lpszCopy, LPCTSTR lpszLink, LPCTSTR lpszNameVersion, LPCTSTR lpszURLToolTip, LPCTSTR lpszTitle,const HICON hIcon, LPCTSTR lpszLinkText);//  " "
	static BOOL RichInRTFTextSel(const HWND hwnd, LPCTSTR lpszText);//   RTF
	static BOOL RichInRTFTextAll(const HWND hwnd, LPCTSTR lpszText);//   RTF
	static BOOL RichInPlainTextSel(const HWND hwnd, LPCTSTR lpszText);//   
	static BOOL RichInPlainTextAll(const HWND hwnd, LPCTSTR lpszText);//   
	static BOOL SetStatusBarText(LPCTSTR lpszText);//    
private:
	static BOOL RichIn(const HWND hwnd, LPCTSTR lpszText, const bool bAsPlainText, const bool bSel);	
public:
	static BOOL SelectPage(const WORD wDocID, const int nPageID, const DWORD dwCursorPos);
	static int DisplayFolderDialogForActiveDoc(const int nSelFolderID, RECT* pRectDlg);
	static CHARFORMAT GetAmlEditorFontAsCHARFORMAT();
	static LOGFONT GetAmlEditorFont();
	static LOGFONT GetAmlTreeFont();
	static int ImportFileToActiveDoc(LPCTSTR lpszPathName);//import file to active doc. RetVal: PageID or success, -1 or fail
	static BOOL ShowPageInTreeInActiveDoc(const int nPageID);
	static BOOL ShowPageInTree(const WORD wDocID, const int nPageID);
	static BOOL MinimizeMainWindow();
	static BOOL RestoreMainWindow();
	static WORD OpenDocumentEx(LPCTSTR lpszFullPathName, const int nPageID);
	static int GetActiveDocumentPath(UINT nBytes, LPTSTR lpszPath);
	static int GetActiveDocumentPathNeedBytes();
	static COLORREF GetAmlColor(const AML_OPTIONS_COLORS colorType);
	static BOOL CopyOrMoveNode(const int nCopiedNodeID, const int nTargetNodeID, const BOOL bCopy);
	static BOOL MoveNode(const int nCopiedNodeID, const int nTargetNodeID);
	static BOOL CopyNode(const int nCopiedNodeID, const int nTargetNodeID);
	static WORD OpenDocument(LPCTSTR lpszDocFullPathName);
	static UINT GetMruList(const UINT nBytes, LPTSTR lpszFileList);
	static UINT GetMruListSizeInBytes();
	static void NewStickyNote(const BOOL bInsertClipboardToContent);
	static BOOL ShowTree(const WORD wDocID, const BOOL bShow);
	static int GetPageHeaderBytesNeed(const int nPageID);
	static int GetPageHeader(const int nPageID, LPTSTR lpszHeader);
	static int GetActivePageID(const WORD wDocumentID=AML_ACTIVEDOCUMENTID);
};

#endif // !defined(AFX_APPHELPER_H__F41D99AE_3171_426F_B928_7854773D682A__INCLUDED_)
